#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/vtkd.h>
#include <sys/console.h>

#define  REFUSE 0		/* user will not release the display    */
#define  RELACK 1		/* user releases the display 		*/
#define  ACQACK 2		/* user acknowledges the acquire signal  */

#define PLANESIZE 80*480

unsigned char *savescreen,*malloc();
int delete();
unsigned char *screen;

int tiefe=64;
int i=0,r=0,ra=0,ci=0,cr=0,s=0;
int  x,y,di,dr,n;

unsigned char lp_init[] = "*r0A*t300R*r640S";

main(argc,argv) 
int argc; char *argv[];
{
	int c;

	di = 9830 / 240;
	dr = 11060 / 320;

	cr = -8192;
	ci = 512;

	ioctl(0,SW_VGA11,0);
	i = ioctl (0,MAPVGA,0);
	if (i==-1) delete(-1);
	screen = (unsigned char *) i;

	for (i=0;i!=32;i++) {
		signal (i,SIG_IGN);
		signal (i,delete);
	}

	for(x = 0; x < 640; x+=2) {
		cr +=  dr;
		ci = 0;
		for(y=0;y<240;y+=2) {
			ci += di;
			i = ci;
			r = cr;
			n = 0;
			do {
				ra = r;
				r = ((ra*ra-i*i) >> 12) + cr;
				i = ((ra*i) >> 11) + ci;
				s = r*r+i*i;
				n++;
			} while ( (n < tiefe) && (s <= 67108864) );
			if (n &  1) plot11 (x,240+y);
			if (n &  1) plot11 (x,240-y);
			if (n &  2) plot11 (x+1,240+y);
			if (n &  2) plot11 (x+1,240-y);
			if (n &  4) plot11 (x,240+y+1);
			if (n &  4) plot11 (x,240-y+1);
			if (n &  8) plot11 (x+1,240+y+1);
			if (n &  8) plot11 (x+1,240-y+1);
		}
	}
	while (1);
}

delete(s)
int s;
{
	if (s == 3) lp_open();

	ioctl (0,SW_VGA80x25,0);
	if (s) {
		fprintf (stderr,"Signal %d received.\n",s);
		fprintf (stderr,"Program terminated\n");
	}
	exit (s);
}

c_plot11(int x, int y) {
	char *s;

	s = screen + y*80 + (x>>3);
	*s |= ( 0x80 >> (x & 7));
}

plot11(x,y)
int x,y;
{
	_asm {
		mov	bx,word ptr y
		imul	bx,80
		mov	ax,word ptr x
		push	ax
		shr	ax,3
		add	bx,ax
		pop	cx
		and	cx,7
		mov	ah,80h
		movzx	ebx,bx
		add	ebx,screen
		shr	ah,cl
		or	byte ptr es:[ebx],ah
	}
}

lp_open() {
	char lpname[] = "/tmp/lp";
	int x,y;
	FILE *lfp;
	char *s;

	if ((lfp=fopen(lpname,"w"))==NULL) {
		ioctl (0,SW_VGA80x25,0);
		fprintf (stderr,"Drucker kann nicht angesprochen werden\n");
		exit (2);
	}
	s = screen;
	for (y=0;y!=480;y++) {
		fprintf (lfp,"%s",lp_init);
		fprintf (lfp,"*b80W");
		for (x=0;x!=80;x++) fputc (*s++,lfp);
	}
	fprintf (lfp,"*rbC");
	pclose (lfp);
}
